package com.javahonk.proto.convert;

import java.io.IOException;
import java.util.List;

import com.javahonk.proto.JavaHonkDateRangeRequestProto;
import com.javahonk.proto.JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo;
import com.javahonk.proto.JavaHonkDateRangeRequestProto.JavaHonkDateRangeRequestInfo;

public class ConvertToByteAndObject {

	public static void main(String[] args) throws IOException {
		
		//Build and convert object to byte array
		System.out.println(buildObjectWithGoogleProtoBuff().toByteArray());
		
		//Fetch value from byte array and convert to real object
		convertedObjectWithValue();
	}
	
	public static CompositeJavaHonkDateRangeRequestInfo buildObjectWithGoogleProtoBuff() {
		
		JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo.Builder compositeJavaHonkDateRangeRequestInfo 
			= JavaHonkDateRangeRequestProto.CompositeJavaHonkDateRangeRequestInfo.newBuilder();
		
		JavaHonkDateRangeRequestInfo.Builder javaHonkDateRangeRequestInfo = JavaHonkDateRangeRequestInfo.newBuilder();
		javaHonkDateRangeRequestInfo.setStartDate("20160628");
		javaHonkDateRangeRequestInfo.setEndDate("20160630");
				
		compositeJavaHonkDateRangeRequestInfo.addJavaHonkDateRangeRequestInfo(javaHonkDateRangeRequestInfo);
		compositeJavaHonkDateRangeRequestInfo.addJavaHonkDateRangeRequestInfo(javaHonkDateRangeRequestInfo);
		
		return compositeJavaHonkDateRangeRequestInfo.build();
	}
	
	public static void convertedObjectWithValue() throws IOException {
		
		byte[] message = buildObjectWithGoogleProtoBuff().toByteArray();
		
		List<JavaHonkDateRangeRequestInfo> compositeSwapResetInfoList = CompositeJavaHonkDateRangeRequestInfo
				.parseFrom(message).getJavaHonkDateRangeRequestInfoList();

		for (JavaHonkDateRangeRequestInfo javaHonkDateRangeRequestInfo : compositeSwapResetInfoList) {
			System.out.println(javaHonkDateRangeRequestInfo.getEndDate());
		}
		
	}

}
